/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.exporter;

import java.util.Set;

import it.eng.spago4q.metadata.S4qEDomainValue;
import it.eng.spago4q.metadata.S4qEInterfaceField;
import it.eng.spago4q.metadata.S4qEInterfaceType;

import com.thoughtworks.xstream.XStream;

public class InterfaceTypeExporter extends AbstractExporter {
	
	public String exportInterfaceType(final S4qEInterfaceType interfaceType){
		return getXStream().toXML(interfaceType);
	}

	public String exportInterfaceTypeSet(final Set<S4qEInterfaceType> interfaceTypeSet){
		return getXStream().toXML(interfaceTypeSet);
	}

	public S4qEInterfaceType importInterfaceType(final String xml){
		return (S4qEInterfaceType)getXStream().fromXML(xml);
	}

	public Set<S4qEInterfaceType> importInterfaceTypeSet(final String xml){
		return (Set<S4qEInterfaceType>)getXStream().fromXML(xml);
	}

	public void setUp(final XStream xstreamPar){
		xstreamPar.alias("interfaceType", S4qEInterfaceType.class);
		xstreamPar.alias("interfaceField", S4qEInterfaceField.class);
		xstreamPar.alias("value", S4qEDomainValue.class);

		xstreamPar.aliasField("interfaceFields", S4qEInterfaceType.class, "s4qEInterfaceFields");
		xstreamPar.aliasField("domainValues", S4qEInterfaceField.class, "s4qEDomainValues");

		xstreamPar.omitField(S4qEInterfaceType.class, "idInterfaceType");
		xstreamPar.omitField(S4qEInterfaceType.class, "s4qEOperations");
		xstreamPar.omitField(S4qEDomainValue.class, "idFieldValue");
		xstreamPar.omitField(S4qEInterfaceField.class, "s4qEOperationFields");
		
		xstreamPar.registerConverter(new DomainValueConverter());
		
	}
}
