/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors;

import it.eng.spago.error.EMFUserError;
import it.eng.spago.security.IEngUserProfile;
import it.eng.spago4q.bo.EOperation;
import it.eng.spago4q.extractors.bo.ExtractorParameter;
import it.eng.spago4q.extractors.bo.GenericItemInterface;
import it.eng.spago4q.extractors.parameterfiller.ExtractionParameterFiller;
import it.eng.spago4q.extractors.script.ScriptExecutor;
import it.eng.spago4q.extractors.utilities.OperationUtil;

import java.util.Date;
import java.util.List;

public abstract class AbstractCoordinator extends TransformAndInsertUtil
        implements OperationCoordinatorInterface {

    protected abstract ExtractionParameterFiller getExtractionParameterFiller();

    protected void executeOperation(final Integer processId,
            final EOperation operation, final Date executionDate,
            final ScriptExecutor scriptExecutor,
            final IEngUserProfile userProfile) throws EMFUserError {
        String archivePath = null;

        ExtractionParameterFiller extractorParameterFiller = getExtractionParameterFiller();
        // set the operation
        extractorParameterFiller.setOperation(operation);
        // get data source parameters
        List<ExtractorParameter> dataSourceParameters = extractorParameterFiller
                .getDataSourceParameters();
        // get operations parameters
        List<ExtractorParameter> operationParameters = extractorParameterFiller
                .getOperationParameters();

        List<GenericItemInterface> genericItemList = OperationUtil
                .executeOperation(operation, dataSourceParameters,
                        operationParameters);
        transformAndInsertData(processId, operation, executionDate,
                executionDate, scriptExecutor, userProfile, archivePath,
                genericItemList);
    }

}
