/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors.tablehandlers;

import it.eng.spago4q.extractors.tablehandlers.mysql.MySqlTableHandler;
import it.eng.spago4q.extractors.tablehandlers.oracle.OracleSqlTableHandler;
import it.eng.spago4q.extractors.tablehandlers.postgresql.PostgreSqlTableHandler;

public final class TableHandlerFactory {
	
    private static final String MYSQLINNODBDIALECT = "org.hibernate.dialect.MySQLInnoDBDialect";
    private static final String POSTGREDBDIALECT = "org.hibernate.dialect.PostgreSQLDialect";
    private static final String ORACLEDBDIALECT = "org.hibernate.dialect.Oracle9Dialect";
    
    
	private TableHandlerFactory(){}

	public static TableHandlerInterface getTableHandler(final String tableHandlerEntry){
		TableHandlerInterface toReturn = null;
		
		if(tableHandlerEntry.equals(MYSQLINNODBDIALECT)) {
			toReturn = new MySqlTableHandler();
		}
		
		if(tableHandlerEntry.equals(POSTGREDBDIALECT)) {
			toReturn = new PostgreSqlTableHandler();
		}

		if(tableHandlerEntry.equals(ORACLEDBDIALECT)) {
	            toReturn = new OracleSqlTableHandler();
		}
		
		return toReturn;
	}
}